import os
import shutil
import random


def create_reduzierte_testdaten():
    # Pfad des Quellordners
    src_dir = '/assets/Bilder/Datengrundlage'

    # Pfad des Zielordners
    dst_dir = '/assets/Bilder/Datengrundlage-Reduziert-Test'

    # Prozentualer Anteil der Bilder, die kopiert werden sollen
    sample_rate = 0.05

    # Erstelle den Zielordner, falls er nicht existiert
    if not os.path.exists(dst_dir):
        os.makedirs(dst_dir)

    # Durchlaufe alle Unterordner des Quellordners
    for subdir, dirs, files in os.walk(src_dir):
        # Erstelle einen entsprechenden Unterordner im Zielordner
        dst_subdir = subdir.replace(src_dir, dst_dir)
        if not os.path.exists(dst_subdir):
            os.makedirs(dst_subdir)

        # Wähle zufällig einen Teil der Bilder aus
        selected_files = random.sample(files, int(len(files) * sample_rate))

        # Kopiere die ausgewählten Bilder in den Zielordner
        for file in selected_files:
            src_file = os.path.join(subdir, file)
            dst_file = os.path.join(dst_subdir, file)
            shutil.copy(src_file, dst_file)


def copy_images_with_exclusion(src_dir, dest_dir, exclude_dir=None):
    # Lösche vorhandene Dateien und Unterordner im Zielordner
    for file_or_dir in os.listdir(dest_dir):
        file_or_dir_path = os.path.join(dest_dir, file_or_dir)
        if os.path.isdir(file_or_dir_path):
            shutil.rmtree(file_or_dir_path)
        else:
            os.remove(file_or_dir_path)

    # Erstelle die gewünschte Ordnerstruktur im Zielverzeichnis
    os.makedirs(os.path.join(dest_dir, '!OOS'))
    os.makedirs(os.path.join(dest_dir, 'OOS'))


    # Durchlaufe die Unterordner im Quellverzeichnis
    for subdir in os.listdir(src_dir):
        #  if subdir == exclude_dir:
        subdirString = bytes(subdir, 'utf-8').decode('unicode_escape')
        exclude_dirString = bytes(exclude_dir.name, 'utf-8').decode('unicode_escape')
        if subdirString == exclude_dirString:
            continue
        for folder in os.listdir(os.path.join(src_dir, subdir)):
            if folder == 'OOS':
                for img in os.listdir(os.path.join(src_dir, subdir, folder)):
                    shutil.copy(os.path.join(src_dir, subdir, folder, img), os.path.join(dest_dir, 'OOS'))
            elif folder == '!OOS':
                for img in os.listdir(os.path.join(src_dir, subdir, folder)):
                    shutil.copy(os.path.join(src_dir, subdir, folder, img), os.path.join(dest_dir, '!OOS'))
