import os
import shutil
import tensorflow as tf
from src.enum.marktEnum import Markt


# Wird nicht mehr gebraucht
def createPathWithPictures():
    # Pfad zu den 6 Ordnern
    main_folder_path = "/assets/Bilder/Datengrundlage"
    # Pfad zum neuen Ordner
    new_folder_path = "/assets/Bilder/Modelldaten/alleMaerkte"


    # Schleife durch die 6 Ordner
    for folder in os.listdir(main_folder_path):
        current_folder = os.path.join(main_folder_path, folder)
        for subfolder in os.listdir(current_folder):
            if subfolder in ["OOS", "!OOS"]:
                subfolder_path = os.path.join(current_folder, subfolder)
                # Erstellen Sie Unterordner im Zielordner mit dem Namen des Unterordners
                new_subfolder_path = os.path.join(new_folder_path, subfolder)
                os.makedirs(new_subfolder_path, exist_ok=True)
                for image in os.listdir(subfolder_path):
                    image_path = os.path.join(subfolder_path, image)
                    # Kopieren Sie die Bilder in den neuen Unterordner im Zielordner
                    shutil.copy(image_path, new_subfolder_path)


def generate_augmented_not_oos_pictures():
    for markt in Markt:
        # Pfad zum Ordner "!OOS"
        folder_path = "assets/Bilder/Datengrundlage_Test/" + markt.name + "/"

        # Erstellen Sie eine Instanz des ImageDataGenerator
        datagen = get_images()

        # Pfad für den neuen Ordner, in dem die augmentierten Bilder gespeichert werden sollen
        save_to_dir = "assets/Bilder/Datengrundlage-Augmentiert/" + markt.name + "/!OOS"

        for i in range(9):
            # Trainingsdaten konfigurieren
            train_it = datagen.flow_from_directory(
                folder_path,
                class_mode='binary',
                batch_size=1425,
                target_size=(224, 224),
                save_to_dir=save_to_dir,
                save_prefix="augmented_" + str(i) + "_",
                save_format='jpg',
            )
            train_it.next()


def get_images():
    augmentedImageDefinition = tf.keras.preprocessing.image.ImageDataGenerator(
        rescale=1. / 224,
        horizontal_flip=True,
        rotation_range=15,
        fill_mode='nearest',
        width_shift_range=0.2,
        height_shift_range=0.2,
        brightness_range=[0.5, 1.5],
        zoom_range=0.5,
    )
    return augmentedImageDefinition


# generateAugmentedNotOOSPictures()
