from src.enum.activierungsfunktionEnum import Aktivierungsfunktion
from src.enum.marktEnum import Markt
from src.enum.optimierungsverfahren import Optimierungsverfahren


class ConfigKNN:
    def __init__(self,
                 excluded_folder=Markt.Kein_Markt,
                 activation_function_128_units=Aktivierungsfunktion.ReLU,
                 activation_function_2_units=Aktivierungsfunktion.sigmoid,
                 optimization_method=Optimierungsverfahren.SGD):
        self.excluded_folder = excluded_folder
        self.activation_function_128_units = activation_function_128_units
        self.activation_function_2_units = activation_function_2_units
        self.optimization_method = optimization_method

    def __str__(self):
        return "optimization_method: " \
            + self.optimization_method.name + " - activation_function_128_units: " \
            + self.activation_function_128_units.name + ' - activation_function_2_units: ' \
            + self.activation_function_2_units.name + ' - excluded_folder: ' \
            + self.excluded_folder.name
