import sys
from matplotlib import pyplot


# plot diagnostic learning curves
def plot_values(history, config):
    # plot loss
    """
    pyplot.subplot(211)
    pyplot.title('Cross Entropy Loss')
    pyplot.plot(history.history['loss'], color='blue', label='train')
    pyplot.plot(history.history['val_loss'], color='orange', label='test')
    """
    # plot accuracy
    pyplot.subplot(212)
    pyplot.title('Classification Accuracy')
    pyplot.plot(history.history['accuracy'], color='blue', label='Accuracy')
    pyplot.plot(history.history['recall_oos'], color='blue', label='Recall OOS')
    pyplot.plot(history.history['recall_not_oos'], color='yellow', label='Recall !OOS')
    pyplot.plot(history.history['val_accuracy'], color='orange', label='Test Accuracy')
    pyplot.plot(history.history['val_recall_oos'], color='red', label='Test Recall OOS')
    pyplot.plot(history.history['val_recall_not_oos'], color='green', label='Test Recall !OOS')
    # save plot to file
    filename = sys.argv[0].split('/')[-1]
    pyplot.savefig(config["result"]["plot_path"] + filename + '_plot.png')
    pyplot.close()
